CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000


OBJ

  v     : "VocalTract"

  
VAR

  byte  aa,ga,gp,vp,vr,f1,f2,f3,f4,na,nf,fa,ff  'vocal tract parameters
  

PUB start

  v.start(@aa, 10, 11, -1)              'start tract, output to pins 10,11
 
  repeat                                'keep repeating talk
    gp := rnd(50, 100)                  'set random glottal pitch
    vp := rnd(4, 24)                    'set random vibrato pitch
    vr := rnd(4, 10)                    'set random vibrato rate
    talk                                'talk


PRI talk

  setformants(310, 2000, 3100, 3700)    'set formants for bEEt
  v.go(1)

  aa := 3                               'set breathiness
  ga := 30                              'set voiced volume
  v.go(100)                             'ramp up
  v.go(500)                             'sustain

  setformants(730, 1700, 2500, 3400)    'set formants for hAt
  v.go(100)                             'transition
  v.go(500)                             'sustain

  setformants(750, 1050, 2400, 3200)    'set formants for hOt
  ga := 12                              'volume down a little
  v.go(100)                             'transition
  v.go(500)                             'sustain   

  setformants(530, 950, 2400, 3200)     'set formants for sOAp
  v.go(100)                             'transition
  v.go(500)                             'sustain   


  setformants(580, 1200, 1500, 4700)    'set formants for boRRow
  v.go(100)                             'transition
  v.go(500)                             'sustain   


  setformants(560, 850, 2600, 3600)     'set formants for baLL
  v.go(100)                             'transition
  v.go(500)                             'sustain   


  aa := 0                               'taper down to silence
  ga := 0
  v.go(100)

  v.go(500)                             'pause


PRI setformants(s1, s2, s3, s4)

  f1 := s1 * 100 / 1953
  f2 := s2 * 100 / 1953
  f3 := s3 * 100 / 1953
  f4 := s4 * 100 / 1953


PRI rnd(low, high)

  return low + ||(?cnt // (high - low + 1))
